/**
  *  \file client/widgets/partstorage.h
  *  \brief Ship Build Screen Part Storage and Image Display
  *
  *  (c) 2001-2013 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_PARTSTORAGE_H
#define PCC_V2_CLIENT_WIDGETS_PARTSTORAGE_H

#include "ui/ui.h"
#include "ui/widgets/imagewidget.h"
#include "ui/widgets/button.h"

// FIXME: those are currently here because we need them here.
// Can we do without them?
enum {
    cm_CountChanged    = 4002,
    cm_BuildComponent  = 4003
};

class WPartStorageDisplay : public UIWidget {
    int n;
 public:
    WPartStorageDisplay();
    void drawContent(GfxCanvas& can);
    void getLayoutInfo(LayoutInfo& info);
    void setCount(int n);
};

class WPartStorageGroup : public UIGroup {
    ObjectHolder h;
    UIImageWidget* image;
    WPartStorageDisplay* psd;
 public:
    WPartStorageGroup(bool withBuild);
    ~WPartStorageGroup();

    void setCount(int n)
        { psd->setCount(n); }

    void setImage(Ptr<GfxPixmap> pix)
        { image->setImage(pix); }
};

#endif
