/**
  *  \file int/subr.h
  *  \brief Interpreter: Subroutine Value
  *
  *  (c) 2001-2013 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef C2SERVER_INT_SUBR_H
#define C2SERVER_INT_SUBR_H

/** Subroutine value. Value referring to a subroutine. This is used to
    implement the 'pushsub' opcode. */
class IntSubroutineValue : public IntValue {
    IntBCORef bco;
 public:
    IntSubroutineValue(IntBCORef bco);
    ~IntSubroutineValue();
    IntBCORef getBytecodeObject();

    string_t toString(bool readable);
    void store(IntTagNode& tag, Stream& aux);
    IntSubroutineValue* clone();
};

#endif
